/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.me.autoconversionfield;

import android.app.Activity;


/**
 *
 * @author hansolo
 */
public class MainActivity extends Activity implements android.view.View.OnFocusChangeListener
{
    private org.me.autoconversionfield.ConversionEditText conversionField;
    private android.widget.Spinner unitTypeSelector;
    private android.widget.Spinner baseUnitSelector;
    private android.widget.EditText decimalField;
    private final java.util.ArrayList UNIT_TYPES = new java.util.ArrayList();
    private final java.util.ArrayList AVAILABLE_UNITS = new java.util.ArrayList();
    private android.widget.ArrayAdapter unitTypeSelectionAdapter;
    private android.widget.ArrayAdapter baseUnitSelectionAdapter;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(android.os.Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        // ToDo add your GUI initialization code here
      
        setContentView(R.layout.main);
        
        UNIT_TYPES.addAll(java.util.Arrays.asList(conversion.UnitType.values()));

        conversionField = (org.me.autoconversionfield.ConversionEditText) findViewById(R.id.conversionField);

        unitTypeSelector = (android.widget.Spinner) findViewById(R.id.unitTypeSelector);
        unitTypeSelectionAdapter = new android.widget.ArrayAdapter(this, android.R.layout.simple_spinner_item, UNIT_TYPES);
        unitTypeSelectionAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        unitTypeSelector.setAdapter(unitTypeSelectionAdapter);
        unitTypeSelector.setSelection(conversion.UnitType.LENGTH.ordinal());
        unitTypeSelector.setOnItemSelectedListener(new android.widget.AdapterView.OnItemSelectedListener()
        {
            @Override
            public void onItemSelected(android.widget.AdapterView<?> parentView, android.view.View selectedItemView, int selectedIndex, long id)
            {
                conversionField.setUnitType(conversion.UnitType.valueOf(unitTypeSelector.getSelectedItem().toString()));

                AVAILABLE_UNITS.clear();
                AVAILABLE_UNITS.addAll(conversionField.getAvailableUnits());
                baseUnitSelectionAdapter.notifyDataSetChanged();
                baseUnitSelector.setSelection(AVAILABLE_UNITS.lastIndexOf(conversionField.getBaseUnit()));
            }

            @Override
            public void onNothingSelected(android.widget.AdapterView<?> parentView)
            {

            }
        });

        AVAILABLE_UNITS.addAll(conversionField.getAvailableUnits());
        baseUnitSelector = (android.widget.Spinner) findViewById(R.id.baseUnitSelector);
        baseUnitSelectionAdapter = new android.widget.ArrayAdapter(this, android.R.layout.simple_spinner_item, AVAILABLE_UNITS);
        baseUnitSelectionAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        baseUnitSelector.setAdapter(baseUnitSelectionAdapter);
        baseUnitSelector.setSelection(AVAILABLE_UNITS.lastIndexOf(conversionField.getBaseUnit().toString()));
        baseUnitSelector.setOnItemSelectedListener(new android.widget.AdapterView.OnItemSelectedListener()
        {
            @Override
            public void onItemSelected(android.widget.AdapterView<?> parentView, android.view.View selectedItemView, int selectedIndex, long id)
            {
                conversionField.setBaseUnit(conversion.UnitDescriptor.valueOf(baseUnitSelector.getSelectedItem().toString()));
            }

            @Override
            public void onNothingSelected(android.widget.AdapterView<?> parentView)
            {

            }
        });

        decimalField = (android.widget.EditText) findViewById(R.id.decimalField);
        decimalField.setText("3");
        decimalField.setOnFocusChangeListener(this);
    }

    @Override
    public void onFocusChange(android.view.View view, boolean hasFocus)
    {
        if (!hasFocus)
        {
            conversionField.setDecimals(Integer.parseInt(decimalField.getText().toString()));
        }
    }
}
